%global forgeurl   https://github.com/iSchluff/graphite-api
%global commit     9ed5bb9e3248c18b7dcd38d26c016044a3e1802f
Version:           1.1.4
%forgemeta -i

Name:           graphite-api
Release:        3%{?dist}
Summary:        Graphite-web, without the interface. Just the rendering HTTP API

License:        ASL 2.0
URL:            %{forgeurl}
Source0:        %{forgesource}
Source1:        graphite-api.yaml
Source2:        graphite-api.sysconfig
Source3:        graphite-api.service
Source4:        graphite-api.sysusers

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  python3-pytest
BuildRequires:  systemd-rpm-macros
BuildRequires:  make
BuildRequires:  python3-sphinx
BuildRequires:  python3-sphinx_rtd_theme
Requires:       python3-gunicorn
Requires(pre):  shadow-utils


%description
Graphite-API is an alternative to Graphite-web, without any built-in dashboard.
Its role is solely to fetch metrics from a time-series database (whisper,
cyanite, etc.) and rendering graphs or JSON data out of these time series. It
is meant to be consumed by any of the numerous Graphite dashboard applications.


%prep
%autosetup -n %{name}-%{commit}


%generate_buildrequires
%pyproject_buildrequires -t


%build
%pyproject_wheel
make -C docs html
# remove hidden file
rm -rvf docs/_build/html/.buildinfo


%install
%pyproject_install
%pyproject_save_files graphite_api

install -Dp -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}.yaml
install -Dp -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -Dp -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service
install -Dp -m 0644 %{SOURCE4} %{buildroot}%{_sysusersdir}/%{name}.conf

mkdir -p %{buildroot}%{_sharedstatedir}/%{name}


%check
%pytest


%pre
# ToDo: Switch to dynamic allocation: https://docs.fedoraproject.org/en-US/packaging-guidelines/UsersAndGroups/
#getent group graphite-api >/dev/null || groupadd -r graphite-api
#getent passwd graphite-api >/dev/null || \
#    useradd -r -g graphite-api -d / -s /sbin/nologin \
#    -c "graphite-api daemon user" graphite-api
#exit 0
%sysusers_create_compat %{SOURCE4}


%post
%systemd_post %{name}.service


%preun
%systemd_preun %{name}.service


%postun
%systemd_postun_with_restart %{name}.service


%files
%doc README.rst
%doc CONTRIBUTING.md
%doc docs/_build/html
%license LICENSE
%config(noreplace) %{_sysconfdir}/graphite-api.yaml
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(0755,graphite-api,graphite-api) %dir %{_sharedstatedir}/graphite-api
%{_unitdir}/%{name}.service
%{_sysusersdir}/%{name}.conf
%{python3_sitelib}/graphite_api*


%changelog
